#include <cmath>
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include "greville.hh"
#include "alglin.hh"

using namespace std ;
using namespace Greville ;

#define NROW 3
#define NCOL 2

int
main() {

  valueType iA[NROW*NCOL], work[NROW+NCOL], B[NROW*NROW+NCOL*NCOL] ;
  valueType A[NROW*NCOL] = { 2, 1, 0, 1, 1, 1 } ;

  pseudoinverse( NROW, NCOL, A, NROW, iA, NCOL, work ) ;
  
  alglin::gemm( "No Transpose", "No Transpose", NROW, NROW, NCOL, 1.0, A, NROW, iA, NCOL, 0.0, B, NROW ) ;
  for ( indexType i = 0 ; i < NROW ; ++i ) {
    for ( indexType j = 0 ; j < NROW ; ++j ) 
     cout << "(A*iA)(" << i << "," << j << ") = " << B[i+NROW*j] << '\n' ;
    cout << '\n' ;
  }

  alglin::gemm( "No Transpose", "No Transpose", NCOL, NCOL, NROW, 1.0, iA, NCOL, A, NROW, 0.0, B, NCOL ) ;
  for ( indexType i = 0 ; i < NCOL ; ++i ) {
    for ( indexType j = 0 ; j < NCOL ; ++j ) 
     cout << "(iA*A)(" << i << "," << j << ") = " << B[i+NCOL*j] << '\n' ;
    cout << '\n' ;
  }
  
}
